!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Interpolates interface geometry.
!latex The interface geometry is given in \verb+Rbc(0:Nvol,1:mn)+ and \verb+Zbs(0:Nvol,1:mn)+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ih00aa(Nvol)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : one
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wih00aa, Icoords, Ni, Lradial
  use cputiming
  use allglobal, only : myid, cpus, mn, im, in, Rbc, Zbs, Ric, Zis, iss

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in) :: Nvol ! this is really global, but convenient to include in argument list to avoid allocations;

  INTEGER             :: ll, imn, ie01bef ! warning :: ll is not global;
  REAL                :: expmm, lssm(0:Nvol), rmn(0:Nvol), zmn(0:Nvol)

  BEGIN(ih00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do imn = 1,mn

   select case(Icoords)

   case(0)
   
 !latex \item If \verb+Icoords.eq.0+, no longer supported. %the coordinates are constructed by a piecewise linear interpolation of the interface harmonics.

    FATALMESS(ih00aa,Icoords.eq.0,Icoords = 0 is no longer supported)

!    Ric(0:Nvol,0,imn) = Rbc(0:Nvol,imn)
!    Zis(0:Nvol,0,imn) = Zbs(0:Nvol,imn)
!
!    Ric(1:Nvol,1,imn) = ( Rbc(1:Nvol,imn) - Rbc(0:Nvol-1,imn) ) / ( iss(1:Nvol)-iss(0:Nvol-1) ) ! linear derivatives;
!    Zis(1:Nvol,1,imn) = ( Zbs(1:Nvol,imn) - Zbs(0:Nvol-1,imn) ) / ( iss(1:Nvol)-iss(0:Nvol-1) ) ! linear derivatives;
    
! what about Ric(0,1,imn) ?

   case(1)
    
!latex \item If \verb+Icoords.eq.1+, the coordinates are constructed by a piecewise cubic interpolation of the interface harmonics, provided by the NAG routine \verb+E01BEF+.

    Ric(0:Nvol,0,imn) = Rbc(0:Nvol,imn)
    Zis(0:Nvol,0,imn) = Zbs(0:Nvol,imn)

    ie01bef=1 ; call E01BEF( Nvol+1 , iss(0:Nvol) , Ric(0:Nvol,0,imn) , Ric(0:Nvol,1,imn) , ie01bef ) 
    FATALMESS(ih00aa,ie01bef.ne.0,error interpolating Ric coordinate harmonics using NAG routine E01BEF)
    
    ie01bef=1 ; call E01BEF( Nvol+1 , iss(0:Nvol) , Zis(0:Nvol,0,imn) , Zis(0:Nvol,1,imn) , ie01bef )
    FATALMESS(ih00aa,ie01bef.ne.0,error interpolating Zis coordinate harmonics using NAG routine E01BEF)

   case(2)

!latex \item If \verb+Icoords.eq.2+, the coordinates are constructed by a piecewise cubic interpolation of the interface harmonics, (manually).
    
    Ric(0:Nvol,0,imn) = Rbc(0:Nvol,imn)
    Zis(0:Nvol,0,imn) = Zbs(0:Nvol,imn)

    Ric(0       ,1,imn) = ( Rbc(1           ,imn) - Rbc(0           ,imn) ) / ( iss(1           ) - iss(0           ) )
    Ric(1:Nvol-1,1,imn) = ( Rbc(1+1:Nvol-1+1,imn) - Rbc(1-1:Nvol-1-1,imn) ) / ( iss(1+1:Nvol-1+1) - iss(1-1:Nvol-1-1) )
    Ric(  Nvol  ,1,imn) = ( Rbc(    Nvol    ,imn) - Rbc(    Nvol-1  ,imn) ) / ( iss(    Nvol    ) - iss(    Nvol-1  ) )
    
    Zis(0       ,1,imn) = ( Zbs(1           ,imn) - Zbs(0           ,imn) ) / ( iss(1           ) - iss(0           ) )
    Zis(1:Nvol-1,1,imn) = ( Zbs(1+1:Nvol-1+1,imn) - Zbs(1-1:Nvol-1-1,imn) ) / ( iss(1+1:Nvol-1+1) - iss(1-1:Nvol-1-1) )
    Zis(  Nvol  ,1,imn) = ( Zbs(    Nvol    ,imn) - Zbs(    Nvol-1  ,imn) ) / ( iss(    Nvol    ) - iss(    Nvol-1  ) )

   case(3)
    
!latex \item If \verb+Icoords.eq.3+, the power $r^{m} \equiv \psi_t^{m/2}$ is extracted before the piecewise cubic interpolation of the interface harmonics,
!latex so that the radial dependence of the coordinate Fourier harmonics is $R_j(s) = s^{m/2} p(s)$, where $p(s)$ is a polynomial fitted to the interfaces
!latex and is interpolated (piecewise-cubic) by the NAG routine \verb+E01BEF+.

    if( im(imn).eq.0 ) then ! additional radial factor is degenerate;
     
     Ric(0:Nvol,0,imn) = Rbc(0:Nvol,imn)
     Zis(0:Nvol,0,imn) = Zbs(0:Nvol,imn)
     
    else
     
     expmm = im(imn) * one/Lradial ; lssm(1:Nvol) = iss(1:Nvol)**expmm
     
     Ric(1:Nvol,0,imn) = Rbc(1:Nvol,imn) / lssm(1:Nvol) ! recal that Ric(0,0,imn) was calculated in ex00aa;
     Zis(1:Nvol,0,imn) = Zbs(1:Nvol,imn) / lssm(1:Nvol) ! recal that Zis(0,0,imn) was calculated in ex00aa;

    endif

    ie01bef=1 ; call E01BEF( Nvol+1 , iss(0:Nvol) , Ric(0:Nvol,0,imn) , Ric(0:Nvol,1,imn) , ie01bef ) 
    FATALMESS(ih00aa,ie01bef.ne.0,error establishing interpolation of Ric coordinate harmonics using NAG routine E01BEF)
    
    ie01bef=1 ; call E01BEF( Nvol+1 , iss(0:Nvol) , Zis(0:Nvol,0,imn) , Zis(0:Nvol,1,imn) , ie01bef )
    FATALMESS(ih00aa,ie01bef.ne.0,error establishing interpolation of Zis coordinate harmonics using NAG routine E01BEF)
    
   case default
    
    FATALMESS(ih00aa,.true.,invalid Icoords)
    
   end select
   
  enddo ! end of do imn=1,mn
  
!latex \item In all cases, the radial derivatives of the coordinate harmonics are saved in \verb+Ric(0:Nvol,1,1:mn)+ and \verb+Zis(0:Nvol,1,1:mn)+.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Wih00aa ) then
   cput = MPI_WTIME()
   do imn=1,mn
    write(ounit,'("ih00aa ; "f10.2" : myid="i3" ; (m,n)=("i3" ,"i3" ) : Ric(:,0,)="99es13.5)')cput-cpus,myid,im(imn),in(imn),Ric(0:Nvol,0,imn)
    write(ounit,'("ih00aa ; "f10.2" : myid="i3" ; (m,n)=("i3" ,"i3" ) : Ric(:,1,)="99es13.5)')cput-cpus,myid,im(imn),in(imn),Ric(0:Nvol,1,imn)
   enddo
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ih00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ih00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
