!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Allocates geometric information.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma00ab

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wma00ab, Nofe, Ni
  use cputiming, only : Tma00ab
  use allglobal, only : myid, cpus, mn, ll, igss, igst, igsz, igtt, igtz, igzz, igoo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER :: il, ip, ir, iq, ij, ik, jk, imj, imk

  BEGIN(ma00ab)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do il = 0 , 1 ! left, right basis function;
   do ip = 0 , Nofe ! basis function; derivative;
    
    do ir = 0 , 1 ! left, right basis function;
     do iq = 0 , Nofe ! basis function; derivative;
      
      jk = 0
      
      do ij = 1 , mn
       do ik = 1 , mn ; jk = jk + 1
        
!latex \item The metric quadratures are stored in \verb$igss(0:1,0:Nofe,0:1,0:Nofe,0:mn*mn)%s(0:Ni(ll)+1)$, etc.
!latex These are defined and calculated in \verb+ma00aa+.
        
        RALLOCATE(igss(il,ip,ir,iq,jk)%s,(1:Ni(ll)))
        RALLOCATE(igst(il,ip,ir,iq,jk)%s,(1:Ni(ll)))
        RALLOCATE(igsz(il,ip,ir,iq,jk)%s,(1:Ni(ll)))
        RALLOCATE(igtt(il,ip,ir,iq,jk)%s,(1:Ni(ll)))
        RALLOCATE(igtz(il,ip,ir,iq,jk)%s,(1:Ni(ll)))
        RALLOCATE(igzz(il,ip,ir,iq,jk)%s,(1:Ni(ll)))
        RALLOCATE(igoo(il,ip,ir,iq,jk)%s,(1:Ni(ll)))
        
       enddo ! end of do ik;
      enddo ! end of do ij;
      
      FATAL(ma00ab,jk.ne.mn*mn)
      
     enddo ! end of do iq;
    enddo ! end of do ir;
    
   enddo ! end of do ip;
  enddo ! end of do il;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ma00ab)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine ma00ab

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


