!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Computes volume.

!latex \item The element of volume $dV\equiv \sqrt g ds d\theta d\zeta$, and $\sqrt g = R(R_s Z_\theta - R_\theta Z_s)$.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The coordinate harmonics, $R=\sum_i R_i \cos(m_i\theta-n_i\zeta)$, are interpolated using piecewise cubic polynomials, 
!latex so that in the $l$-th annulus bounded by the $l-1$ and $l$ interfaces
!latex \be R_i(s)&=&R_{l-1,0,i}\varphi_{0,0}+R_{l-1,1,i}\varphi_{0,1}+R_{l-1,0,i}\varphi_{1,0}+R_{l,1,i}\varphi_{1,1} \ee
!latex with the cubic basis functions:
!latex \be \varphi_{0,0}(x) &=& 2 x^3 - 3 x^2 + 1 ,\\
!latex     \varphi_{0,1}(x) &=& x^3 - 2 x^2 + x , \\
!latex     \varphi_{1,0}(x) &=& -2 x^3 + 3 x^2 , \\
!latex     \varphi_{1,1}(x) &=& x^3 - x^2. 
!latex \ee

!latex From this we obtain 
!latex \be R = R_{l-1,0,i} + R_{l-1,1,i} x + (-3R_{l-1,0,i}-2R_{l-1,1,i}+3R_{l-1,0,i}-R_{l,1,i})x^2 + (2R_{l-1,0,i}+R_{l-1,1,i}-2R_{l-1,0,i}+R_{l,1,i})x^3 
!latex \ee

!latex \item
!latex \be V = \sum_{i,j,k} \left[ m_k \int \! ds R_i R^\prime_j Z_k \; \ooint c_i c_j c_k + m_j \int \! ds R_i R_j Z^\prime_k \; \ooint c_i s_j s_k \right]
!latex \ee

subroutine vo00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wvo00aa, Icoords
  use cputiming
  use allglobal, only : myid, cpus, mn, im, in, Ric, Zis, ll, iss, aijk, bijk, volume, pi2pi2nfpquarter

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER :: imn, jmn, kmn, mm, nn, pp
  REAL    :: lds, Rim(0:3), Rjn(0:3), Zkp(0:3)

  BEGIN(vo00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  lds = ( iss(ll) - iss(ll-1) ) ! shorthand;

  volume(0,ll) = zero ! initialize;
  
  select case(Icoords)
   
  case(1:2)
      
   do imn = 1,mn
    do jmn = 1,mn
     do kmn = 1,mn
      
      if( aijk(imn,jmn,kmn).ne.0 .or. bijk(imn,jmn,kmn).ne.0 ) then
       
       Rim(0:3) = (/ + 1 * Ric(ll-1,0,imn)                                                                           , &
                                           + 1 * Ric(ll-1,1,imn)*lds                                                 , &
                     - 3 * Ric(ll-1,0,imn) - 2 * Ric(ll-1,1,imn)*lds + 3 * Ric(ll  ,0,imn) - 1 * Ric(ll  ,1,imn)*lds , &
                     + 2 * Ric(ll-1,0,imn) + 1 * Ric(ll-1,1,imn)*lds - 2 * Ric(ll  ,0,imn) + 1 * Ric(ll  ,1,imn)*lds /)

       Rjn(0:3) = (/ + 1 * Ric(ll-1,0,jmn)                                                                           , &
                                           + 1 * Ric(ll-1,1,jmn)*lds                                                 , &
                     - 3 * Ric(ll-1,0,jmn) - 2 * Ric(ll-1,1,jmn)*lds + 3 * Ric(ll  ,0,jmn) - 1 * Ric(ll  ,1,jmn)*lds , &
                     + 2 * Ric(ll-1,0,jmn) + 1 * Ric(ll-1,1,jmn)*lds - 2 * Ric(ll  ,0,jmn) + 1 * Ric(ll  ,1,jmn)*lds /)

       Zkp(0:3) = (/ + 1 * Zis(ll-1,0,kmn)                                                                           , &
                                           + 1 * Zis(ll-1,1,kmn)*lds                                                 , &
                     - 3 * Zis(ll-1,0,kmn) - 2 * Zis(ll-1,1,kmn)*lds + 3 * Zis(ll  ,0,kmn) - 1 * Zis(ll  ,1,kmn)*lds , &
                     + 2 * Zis(ll-1,0,kmn) + 1 * Zis(ll-1,1,kmn)*lds - 2 * Zis(ll  ,0,kmn) + 1 * Zis(ll  ,1,kmn)*lds /)

!latex \item The trigometric factors \verb+aijk+ and \verb+bijk+ are calculated in \verb+al00aa+.

       do mm = 0,3
        do nn = 0,3
         do pp = 0,3
          
          if( aijk(imn,jmn,kmn).ne.0 .and. nn.ge.1 ) volume(0,ll) = volume(0,ll) + aijk(imn,jmn,kmn) * Rim(mm) * Rjn(nn) * Zkp(pp) * nn / ( mm + nn + pp )
          if( bijk(imn,jmn,kmn).ne.0 .and. pp.ge.1 ) volume(0,ll) = volume(0,ll) + bijk(imn,jmn,kmn) * Rim(mm) * Rjn(nn) * Zkp(pp) * pp / ( mm + nn + pp )
          
         enddo ! end of do mm
        enddo ! end of do nn
       enddo ! end of do pp
       
      endif ! end of if( aijk(imn,jmn,kmn) .ne. 0 .or. bijk(imn,jmn,kmn) .ne. 0 ) then
 
     enddo ! end of do kmn
    enddo ! end of do jmn
   enddo ! end of do imn

   volume(0,ll) = volume(0,ll) * pi2pi2nfpquarter

  case default
   
   if( Wvo00aa) then
    write(ounit,'("vo00aa : "f10.2" : myid="i3" ; ll="i3" ; volume integral not implemented for Icoords.eq."i1" ;")')cpui-cpus,myid,ll,Icoords
   endif
   
  end select

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Wvo00aa ) then ; cput = MPI_WTIME() ; write(ounit,'("vo00aa : "f10.2" : myid="i3" ; volume(0,"i3" )="es23.15" ;")')cput-cpus,myid,ll,volume(0,ll)
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(vo00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine vo00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


